#include "SoftwareSerial.h"
#include <AFMotor.h>
#include <Servo.h>

#define trigger A4 //18
#define echo A5 //M19

float time = 0, distance = 0;
int state;
int num = 0;  // variable to store the servo position
long dur;
long tocm;
bool UDSscanFlag = false;
void UDS_read();
void BLE_cmd_read();

AF_DCMotor motor1(1);
AF_DCMotor motor2(2);
Servo myservo;  // create servo object to control a servo
SoftwareSerial MyBlue(2, 3); // RX | TX

void setup()
{
  pinMode(trigger, OUTPUT);
  pinMode(echo, INPUT);
  myservo.attach(10);
  Serial.begin(9600);
  MyBlue.begin(9600);  //Baud Rate for AT-command Mode.
  motor1.setSpeed(255);
  motor2.setSpeed(255);
  motor1.run(RELEASE);
  motor2.run(RELEASE);
  myservo.write(90);
}

void loop()
{
  UDS_read();
  BLE_cmd_read();
}
void UDS_read()
{
  digitalWrite(trigger, LOW);
  delayMicroseconds(2);
  digitalWrite(trigger, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigger, LOW);
  //  delayMicroseconds(2);
  dur = pulseIn(echo, HIGH);
  tocm = dur * 0.0340 / 2;
  Serial.print("distance : ");
  Serial.println(tocm);
  delay(100);
  if (UDSscanFlag == true)
  {
    if ((tocm > 9) && (tocm < 16)) {
      motor1.run(RELEASE);
      motor2.run(RELEASE);
      delay(1000);
      motor1.run(BACKWARD);
      motor2.run(BACKWARD);
      delay(3000);
      motor1.run(RELEASE);
      motor2.run(RELEASE);
      for (int num = 90; num >= 0; num--)
      {
        myservo.write(num);//back to 'num' degrees(180 to 0)
        delay(50);//control servo speed
      }
      for (num = 90; num <= 180; num++)
      {
        myservo.write(num);//back to 'num' degrees(0 to 180)
        delay(50);//control servo speed
      }
      myservo.write(90);
    }
  }
}

void BLE_cmd_read()
{
  if (MyBlue.available() > 0)
  {
    state = MyBlue.read();
    Serial.println(state);
    if (state == 'S')
    {
      UDSscanFlag = false;
      motor1.run(RELEASE);
      motor2.run(RELEASE);
    }
    if (state == 'F')
    {
      UDSscanFlag = true;
      motor1.run(FORWARD);
      motor2.run(FORWARD);
      delay(500);
    }
    if (state == 'B')
    {
      UDSscanFlag = true;
      motor1.run(BACKWARD);
      motor2.run(BACKWARD);
    }
    if (state == 'L')
    {
      UDSscanFlag = true;
      motor1.run(BACKWARD);
      motor2.run(FORWARD);
    }
    if (state == 'R')
    {
      UDSscanFlag = true;
      motor1.run(FORWARD);
      motor2.run(BACKWARD);
    }
  }
}
